require('randomlua')

function love.load()
	wd, ht = 730, 600
	love.graphics.setMode( wd, ht, {} )
	l1 = lcg(0) -- Linear congruential generator (Ansi C params)
	l2 = lcg(0, 'nr') --Linear congruential generator (Numerical recipes params)
	l3 = lcg(0, 'mvc') -- Linear congruential generator (Microsoft Visual C params)
	c1 = mwc(0) -- Multiply-with-carry (Ansi C params)
	c2 = mwc(0, 'nr') -- Multiply-with-carry (Numerical recipes params)
	c3 = mwc(0, 'mvc') -- Multiply-with-carry (Microsoft Visual C params)
	m = twister(0) -- Mersenne twister
	tl1 = {} tl2 = {} tl3 = {} tc1 = {} tc2 = {} tc3 = {} tm = {}
	scale = 1
	num = 100000 * scale
	for n = 1, num do
		--table.insert(tl1, l1:random(0))
		--table.insert(tl2, l2:random(0))
		--table.insert(tl3, l3:random(0))
		table.insert(tc1, c1:random(360))
		table.insert(tc2, c2:random(360))
		table.insert(tc3, c3:random(360))
		table.insert(tm, m:random(360))
		end
	rangeTM = {} rangeTC3 = {} rangeTC2 = {} rangeMR={}
	mn,mx = 100,0
	for i=1,400 do rangeTM[i] = 0  rangeTC3[i]=0 rangeTC2[i]=0 rangeMR[i]=0 end
	for i=1,#tm do
		ix = math.floor(tm[i])
		rangeTM[ix]=rangeTM[ix]+1
		ix = math.floor(tc3[i])
		rangeTC3[ix]=rangeTC3[ix]+1
		ix = math.floor(tc2[i])
		rangeTC2[ix]=rangeTC2[ix]+1
		ix = math.floor(math.random(360))
		rangeMR[ix]=rangeMR[ix]+1
		end
	love.graphics.setCaption( 'Random Testing' )
	end

function love.draw(dt)
	love.graphics.setColor(255,0,0)
	for i=1,#rangeTM do
		love.graphics.circle('line',2*i+5,rangeTM[i]*1.8/scale,2)
		end
	love.graphics.setColor(0,0,255)
	for i=1,#rangeTC3 do
		love.graphics.circle('line',2*i+5,rangeTC3[i]*1.8/scale,2)
		end
	love.graphics.setColor(0,255,0)
	for i=1,#rangeTC2 do
		love.graphics.circle('line',2*i+5,rangeTC2[i]*1.8/scale,2)
		end
	love.graphics.setColor(255,255,0)
	for i=1,#rangeMR do
		love.graphics.circle('line',2*i+5,rangeMR[i]*1.8/scale,2)
		end

	showAxes(20,200, 50, 50,'number', 'frequency' )

	love.graphics.line(0,520,wd,520)
	love.graphics.line(0,480,wd,480)
	love.graphics.print('number of samples: '..num,10,20)

	for i=1,#rangeTM do
		x=rangeMR[i]*math.cos(i*math.pi/180)/(2*scale)+wd/2
		y=rangeMR[i]*math.sin(i*math.pi/180)/(2*scale)+ht/3
		love.graphics.circle('line',x,y,2)
		end
	for j=1,100 do for i=1,100 do
		love.graphics.setColor(math.random(255),math.random(255),math.random(255))
		love.graphics.circle('line',i+10,j+50,1)
		end end
	love.graphics.setColor(255,255,0)
	for i=270,360,5 do
		local x1=100*math.cos(i*math.pi/180)+wd/2
		local y1=100*math.sin(i*math.pi/180)+ht/3
		x2=100*math.cos((i+5)*math.pi/180)+wd/2
		y2=100*math.sin((i+5)*math.pi/180)+ht/3
		love.graphics.line(x1,y1,x2,y2)
		end
	love.graphics.line(x2,y2,x2-5,y2-10)
	love.graphics.line(x2,y2,x2+5,y2-10)
	love.graphics.print('number',x2-35,y2+5)
	love.graphics.line(wd/2,200,wd/2+50,150)
	love.graphics.line(wd/2+50,150,wd/2+30,155)
	love.graphics.line(wd/2+50,150,wd/2+45,168)
	love.graphics.print('freq.',wd/2+30,175)
	love.graphics.setColor(255,0,0)
	love.graphics.print('Mersenne twister',540,300)
	love.graphics.setColor(0,0,255)
	love.graphics.print('Multiply-with-carry',540,320)
	love.graphics.setColor(0,255,0)
	love.graphics.print('Multiply-with-carry (Numerical)',540,340)
	love.graphics.setColor(255,255,0)
	love.graphics.print('math.random',540,360)
	end

function showAxes( ax, ay, lx, ly, capx, capy )
	capx=capx or 'X-axes'
	capy=capy or 'Y-axes'
	if lx<0 then px=-10 else px=10 end
	if ly<0 then py=-10 else py=10 end
	love.graphics.line(ax,100+ay,lx+ax,100+ay)
	love.graphics.line(lx+ax, 95+ay, px+lx+ax,100+ay)
	love.graphics.line(lx+ax,105+ay, px+lx+ax,100+ay)
	love.graphics.print(capx,15+lx+ax,92+ay)
	love.graphics.line(ax,100+ay,ax,100+ly+ay)
	love.graphics.line(ax-5,100+ly+ay,ax,100+py+ly+ay)
	love.graphics.line(ax+5,100+ly+ay,ax,100+py+ly+ay)
	love.graphics.print(capy,ax-10,100+2*py+ly+ay)
	end

function love.keypressed( key )
	if key == 'escape'	then love.event.push( 'quit' )	end
	end
